<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\DashboardService;

class DashboardController extends FMCrud{
   protected $DashboardService;
   
    public function __construct($crudService, $environment, DashboardService $DashboardService) {
        parent::__construct($crudService, $environment);
        $this->DashboardService = $DashboardService;
    }
  
  public function getDadosLimpezaFinalizada(DTO\Request $request, DTO\Response $response) {
      $dadosLimpezaFinalizada = $this->DashboardService->getDadosLimpezaFinalizada();
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }
  
  public function getDadosTarefaAtrasada(DTO\Request $request, DTO\Response $response) {
      $dadosLimpezaFinalizada = $this->DashboardService->getDadosTarefaAtrasada();
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }

  public function getDadosTarefaConcluida(DTO\Request $request, DTO\Response $response) {
      $dadosLimpezaFinalizada = $this->DashboardService->getDadosTarefaConcluida();
      $dtsVal = new DataSet('dados', $dadosLimpezaFinalizada);
      $response->addDataSet($dtsVal);
  }
  
  public function getDadosProgress(DTO\Request $request, DTO\Response $response) {
    $dadosProgress = $this->DashboardService->getDadosProgress();
    $dtsVal = new DataSet('dados', $dadosProgress);
    $response->addDataSet($dtsVal);
  }
  
  // requisição para retorno dos dados para o card (Ultimas Tarefas Realizadas) Dashboard Supervisor
  public function getDadosUltimasTarefas(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $dadosChecagemLimpeza = $this->DashboardService->getDadosUltimasTarefas($param);
    $dtsVal = new DataSet('dados', $dadosChecagemLimpeza);
    $response->addDataSet($dtsVal);
  }
  
  // requisição para retorno dos dados para o card (Resumo de Tarefas) Dashboard Supervisor(Tarefas Diárias)
  public function getDadosResumoTarefas(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $dadosTarefaDiaria = $this->DashboardService->getDadosResumoTarefas($param);
    $dtsVal = new DataSet('dados', $dadosTarefaDiaria);
    $response->addDataSet($dtsVal);
  }
  
  // requisição para retorno dos dados do grafico Tarefas Realizadas Dashboard Supervisor
  public function getDadosChartTarefas(DTO\Request $request, DTO\Response $response) {
    $dadosTarefaDiaria = $this->DashboardService->getDadosChartTarefas();
    $dtsVal = new DataSet('dados', $dadosTarefaDiaria);
    $response->addDataSet($dtsVal);
  }

  // requisição para retorno dos dados para o grafico Não Conformidades Dashboard Supervisor
  public function getDadosChartNaoConformidades(DTO\Request $request, DTO\Response $response) {
    $dadosChartNaoConformidades = $this->DashboardService->getDadosChartNaoConformidades();
    $dtsVal = new DataSet('dados', $dadosChartNaoConformidades);
    $response->addDataSet($dtsVal);
  }
  
  // requisição para retorno dos dados para grafico Progresso Diario Dashboard Supervisor(Tarefas Diárias)
  public function getDadosChartProgressoDiario(DTO\Request $request, DTO\Response $response) {
    $dadosChartProgressoDiario = $this->DashboardService->getDadosChartProgressoDiario();
    $dtsVal = new DataSet('dados', $dadosChartProgressoDiario);
    $response->addDataSet($dtsVal);
  }
}
?>